<?php
/*
VideoWhisper Live Streaming Integration (for Joomla):

Copyright (C) 2009  VideoWhisper.com

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die();

header('Cache-Control: no-cache');
header('Pragma: no-cache');
setcookie("videowhisper_com",time(),time()+3600);

jimport( 'joomla.application.component.model' );

class VwModelFlash extends JModel
{


function getOutput($task)
	{
  	$params = &JComponentHelper::getParams( 'com_videowhisperlivestreaming' );
	$rtmp_server=urlencode($params->get( 'rtmp' ));
	$welcome_broadcasters=urlencode($params->get( 'welcome_broadcasters'));
	$welcome_watchers=urlencode($params->get( 'welcome_watchers'));
	$bandwidth=$params->get( 'bandwidth');
	$maxbandwidth=$params->get( 'maxbandwidth');
	
	$visitors_watch=urlencode($params->get( 'visitors_watch'));
//	$visitors_watch=1;
	$cpath="components/com_videowhisperlivestreaming/";

	switch ($task)
	{
	case "lb_login":
	$message="";
	$user =& JFactory::getUser();
	if (!$user->get('id')) $loggedin=0; else $loggedin=1;
	if (!$loggedin) $message=urlencode("<a href=\"/\">Please login to your member account first!</a>");
	$username=$user->get('name');
	$usertype=$user->usertype;
	$username=preg_replace("/[^0-9a-zA-Z]/","-",$username);
	
	if (!$rtmp_server || $rtmp_server=="rtmp://your_server/videowhisper")
	{
		$loggedin=0;
		$message=urlencode("Setup RTMP server from component parameters in administrator area!");
		$rtmp_server="rtmp://your_server/videowhisper";
	}


	$base=JURI::root().$cpath;

	$linkcode=JURI::root()."index.php?option=com_videowhisperlivestreaming&view=channel&n=".urlencode($username);
	$imagecode=$base."snapshots/".urlencode($username).".jpg";
	$swfurl=$base."live_watch.swf?n=".urlencode($username);
	$swfurl2=$base."live_video.swf?n=".urlencode($username);

	$embedcode =<<<EMBEDEND
<object width="640" height="350"><param name="movie" value="$swfurl"></param><param name="allowFullScreen" value="true"></param><param name="allowscriptaccess" value="always"></param><embed src="$swfurl" type="application/x-shockwave-flash" allowscriptaccess="always" allowfullscreen="true" width="640" height="350"></embed></object>
EMBEDEND;

	$embedvcode =<<<EMBEDEND2
<object width="320" height="240"><param name="movie" value="$swfurl2"></param><param name="allowFullScreen" value="true"></param><param name="allowscriptaccess" value="always"></param><embed src="$swfurl2" type="application/x-shockwave-flash" allowscriptaccess="always" allowfullscreen="true" width="320" height="240"></embed></object>
EMBEDEND2;

		$linkcode=urlencode($linkcode);
		$embedcode=urlencode($embedcode);
		$embedvcode=urlencode($embedvcode);

		return "server=$rtmp_server&room=$username&welcome=$welcome_broadcasters&username=$username&webserver=&msg=$message&loggedin=$loggedin&imagecode=$imagecode&linkcode=$linkcode&embedcode=$embedcode&embedvcode=$embedvcode&showTimer=1&showCredit=1&disconnectOnTimeout=1&camWidth=320&camHeight=240&camFPS=15&micRate=11&camBandwidth=$bandwidth&showCamSettings=1&advancedCamSettings=1&camMaxBandwidth=$maxbandwidth&generateSnapshots=1&loadstatus=1";
	break;
	case "lw_login":
	case "lv_login":
	$message="";
	$user =& JFactory::getUser();
	if (!$user->get('id')) $loggedin=0; else $loggedin=1;
	if (!$loggedin) $message=urlencode("<a href=\"/\">Please login to your member account first!</a>");
	if ($loggedin) $username=$user->get('name');
	$visitor=0;


  if ($username)
    {
  //look for live session with same username to prevent session name replication
  $db = &JFactory::getDBO();
  $query = "SELECT * FROM #__vw_sessions where status='1' and type='1' and username='$username'";
  $db->setQuery($query);
	$room = $db->loadObject();
	if ($room)
	{
	   $username.="_".base_convert((time()-1224350000).rand(0,100),10,36);
  }
    }



	if ($visitors_watch)
	{
		if (!$username)
		{
			$username="VW".base_convert((time()-1224350000).rand(0,100),10,36);
			$visitor=1;
		}
		$loggedin=1;
	}

	return "server=$rtmp_server&welcome=$welcome_watchers&username=$username&msg=$message&visitor=$visitor&loggedin=$loggedin&loadstatus=1";
	break;
	case "lb_status":

	$db =& JFactory::getDBO();

	$s = JRequest::getVar( 's' );
	$u = JRequest::getVar( 'u' );
	$r = JRequest::getVar( 'r' );
	$m = JRequest::getVar( 'm' );

	$currentTime = JRequest::getVar( 'ct' );
	$lastTime = JRequest::getVar( 'lt' );

	$maximumSessionTime=0; //(miliseconds, 900000ms=15 minutes) change for limiting session time

	$disconnect=""; //anything else than "" will disconnect with that message

	$ztime=time();

	$sql = "SELECT * FROM #__vw_sessions where session='$s' and status='1'";
	$db->setQuery( $sql );
	$session = &$db->loadObject();
	if (!$session)
	{
	$sql="INSERT INTO `#__vw_sessions` ( `session`, `username`, `room`, `message`, `sdate`, `edate`, `status`, `type`) VALUES ('$s', '$u', '$r', '$m', $ztime, $ztime, 1, 1)";
    $db->setQuery( $sql );
  	$db->query();
	}
	else
	{
	$sql="UPDATE `#__vw_sessions` set edate=$ztime, room='$r', username='$u', message='$m' where session='$s' and status='1'";
    $db->setQuery( $sql );
  	$db->query();
	}

	$exptime=$ztime-30;
	$sql="DELETE FROM `#__vw_sessions` WHERE edate < $exptime";
    $db->setQuery( $sql );
  	$db->query();
	return "timeTotal=$maximumSessionTime&timeUsed=$currentTime&lastTime=$currentTime&disconnect=$disconnect&loadstatus=1";
	break;
	case "v_status":
	$s = JRequest::getVar( 's' );
	$u = JRequest::getVar( 'u' );
	$r = JRequest::getVar( 'r' );
	$currentTime = JRequest::getVar( 'ct' );
	$lastTime = JRequest::getVar( 'lt' );

	$maximumSessionTime=0; //(miliseconds, 900000ms=15 minutes) change for limiting session time
	$disconnect=""; //anything else than "" will disconnect with that message

	return "timeTotal=$maximumSessionTime&timeUsed=$currentTime&lastTime=$currentTime&disconnect=$disconnect&loadstatus=1";
	break;
	case "snapshots":
	$received=0;
	
	$GLOBALS["HTTP_RAW_POST_DATA"]= file_get_contents( 'php://input' );
	
	if (isset($GLOBALS["HTTP_RAW_POST_DATA"]))
{
	  $stream=JRequest::getVar('name');

	// get bytearray
	$jpg = $GLOBALS["HTTP_RAW_POST_DATA"];

	// save file
  $fp=fopen($cpath."snapshots/$stream.jpg","w");
  if ($fp)
  {
    fwrite($fp,$jpg);
    fclose($fp);
  }
  	$received=1;
}
	return "received=$received&loadstatus=1";
	break;
	default:
	return "error=$task-NotSupported";
	break;
	}

    }
}